# Enum rustc_mir_build::build::BlockFrame

source ·

    enum BlockFrame {
        Statement {
            ignores_expr_result: bool,
        },
        TailExpr {
            tail_result_is_ignored: bool,
            span: Span,
        },
        SubExpr,
    }

## Variants§

§

### Statement

#### Fields

§`ignores_expr_result: bool`

If true, then statement discards result from evaluating the expression (such as examples 1 and 2 above).

Evaluation is currently within a statement.

Examples include:

1. `EXPR;`
2. `let _ = EXPR;`
3. `let x = EXPR;`

§

### TailExpr

#### Fields

§`tail_result_is_ignored: bool`

If true, then the surrounding context of the block ignores the result of evaluating the block’s tail expression.

Example: `let _ = { STMT_1; EXPR };`

§`span: Span`

`Span` of the tail expression.

Evaluation is currently within the tail expression of a block.

Example: `{ STMT_1; STMT_2; EXPR }`

§

### SubExpr

Generic mark meaning that the block occurred as a subexpression where the result might be used.

Examples: `foo(EXPR)`, `match EXPR { ... }`

## Implementations§

source§

### impl BlockFrame

source

#### fn is_tail_expr(&self) -> bool

source

#### fn is_statement(&self) -> bool

## Trait Implementations§

source§

### impl Debug for BlockFrame

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
source§

### impl PartialEq for BlockFrame

source§

#### fn eq(&self, other: &BlockFrame) -> bool

This method tests for `self` and `other` values to be equal, and is used by `==`.
1.0.0 · source§

#### fn ne(&self, other: &Rhs) -> bool

This method tests for `!=`. The default implementation is almost always sufficient, and should not be overridden without very good reason.
source§

### impl Eq for BlockFrame

source§

### impl StructuralEq for BlockFrame

source§

### impl StructuralPartialEq for BlockFrame

## Auto Trait Implementations§

§

### impl RefUnwindSafe for BlockFrame

§

### impl Send for BlockFrame

§

### impl Sync for BlockFrame

§

### impl Unpin for BlockFrame

§

### impl UnwindSafe for BlockFrame

## Blanket Implementations§

source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 12 bytes

Size for each variant:

- `Statement`: 1 byte
- `TailExpr`: 11 bytes
- `SubExpr`: 0 bytes